Chapter 9 Oracle Examples

9.1 (Oracle 9i through 12c)
SELECT OfferNo, CourseNo, Offering.FacNo, Faculty.FacNo, 
       FacFirstName, FacLastName
 FROM Offering LEFT JOIN Faculty 
      ON Offering.FacNo = Faculty.FacNo
 WHERE CourseNo LIKE 'IS%';

9.1 (Oracle 8i)
SELECT OfferNo, CourseNo, Offering.FacNo, Faculty.FacNo, 
       FacFirstName, FacLastName
 FROM Faculty, Offering
 WHERE Offering.FacNo = Faculty.FacNo (+) 
   AND CourseNo LIKE 'IS%';

9.2 (Oracle 9i through 12c)
SELECT OfferNo, CourseNo, Offering.FacNo, Faculty.FacNo, 
       FacFirstName, FacLastName
 FROM Faculty RIGHT JOIN Offering 
      ON Offering.FacNo = Faculty.FacNo
 WHERE CourseNo LIKE 'IS%';

9.2 (Oracle 8i only)
SELECT OfferNo, CourseNo, Offering.FacNo, Faculty.FacNo, 
       FacFirstName, FacLastName
 FROM Faculty, Offering
 WHERE Faculty.FacNo (+) = Offering.FacNo 
   AND CourseNo LIKE 'IS%';

9.3 (Oracle 9i through 12c)
SELECT FacNo, FacFirstName, FacLastName, FacSalary,
       StdNo, StdFirstName, StdLastName, StdGPA
 FROM Faculty FULL JOIN Student 
      ON Student.StdNo = Faculty.FacNo;

9.4 (Oracle 8i)
SELECT FacNo, FacFirstName, FacLastName, FacSalary,
       StdNo, StdFirstName, StdLastName, StdGPA
 FROM Faculty, Student
 WHERE Student.StdNo = Faculty.FacNo (+)
		UNION
SELECT FacNo, FacFirstName, FacLastName, FacSalary,
       StdNo, StdFirstName, StdLastName, StdGPA
 FROM Faculty, Student
 WHERE Student.StdNo (+) = Faculty.FacNo;

9.5 (Oracle 9i through 12c)
SELECT OfferNo, Offering.CourseNo, OffTerm, CrsDesc,
       Faculty.FacNo, FacFirstName, FacLastName
 FROM ( Faculty RIGHT JOIN Offering 
      ON Offering.FacNo = Faculty.FacNo )
   INNER JOIN Course 
      ON Course.CourseNo = Offering.CourseNo
 WHERE Course.CourseNo LIKE 'IS%' AND OffYear = 2017;

9.5 (Oracle 8i; also works in later Oracle versions)
SELECT OfferNo, Offering.CourseNo, OffTerm, CrsDesc,
       Faculty.FacNo, FacFirstName, FacLastName
 FROM Faculty, Offering, Course
 WHERE Offering.FacNo = Faculty.FacNo (+)
   AND Course.CourseNo = Offering.CourseNo
   AND Course.CourseNo LIKE 'IS%' AND OffYear = 2017;

9.6 (Oracle 9i through 12c)
SELECT DISTINCT Offering.OfferNo, Offering.CourseNo,
       OffTerm, CrsDesc, Faculty.FacNo, FacFirstName,
       FacLastName
 FROM ( ( Faculty RIGHT JOIN Offering 
      ON Offering.FacNo = Faculty.FacNo )
	INNER JOIN Course 
      ON Course.CourseNo = Offering.CourseNo )
	INNER JOIN Enrollment 
      ON Offering.OfferNo = Enrollment.OfferNo
 WHERE Offering.CourseNo LIKE 'IS%' AND OffYear = 2017;

9.6 (Oracle 8i)
SELECT DISTINCT Offering.OfferNo, Offering.CourseNo,
       OffTerm, CrsDesc, Faculty.FacNo, FacFirstName,
       FacLastName
 FROM Faculty, Offering, Course, Enrollment
 WHERE Offering.FacNo = Faculty.FacNo (+)
   AND Course.CourseNo = Offering.CourseNo
 	AND Offering.OfferNo = Enrollment.OfferNo
   AND Course.CourseNo LIKE 'IS%' AND OffYear = 2017;

9.6a
SELECT DISTINCT Offering.OfferNo, Offering.CourseNo,
       OffTerm, CrsDesc, Faculty.FacNo, FacFirstName,
       FacLastName
 FROM Faculty LEFT JOIN 
   ( ( Offering INNER JOIN Course 
      ON Course.CourseNo = Offering.CourseNo )
	INNER JOIN Enrollment 
      ON Offering.OfferNo = Enrollment.OfferNo )
      ON Offering.FacNo = Faculty.FacNo
 WHERE Offering.CourseNo LIKE 'IS%' AND OffYear = 2017


9.6b 
SELECT Offering.OfferNo, Offering.CourseNo,
       OffTerm, CrsDesc, Faculty.FacNo, FacFirstName,
       FacLastName
 FROM (Faculty LEFT JOIN Offering 
      ON Offering.FacNo = Faculty.FacNo)  
  INNER JOIN Course ON Course.CourseNo = Offering.CourseNo

9.6c
SELECT Offering.OfferNo, Offering.CourseNo,
       OffTerm, CrsDesc, Faculty.FacNo, FacFirstName,
       FacLastName
 FROM (Offering INNER JOIN course 
      ON course.courseno = offering.courseno)  
   RIGHT JOIN faculty ON offering.facno = faculty.facno


9.7
SELECT StdNo, StdFirstName, StdLastName, StdMajor
 FROM Student
 WHERE Student.StdNo IN
  ( SELECT StdNo FROM Enrollment 
      WHERE EnrGrade >= 3.5  );

9.8
SELECT StdFirstName, StdLastName, StdCity, EnrGrade
 FROM Student INNER JOIN Enrollment 
	   ON Student.StdNo = Enrollment.StdNo
 WHERE EnrGrade >= 3.5 AND Enrollment.OfferNo IN
  ( SELECT OfferNo FROM Offering 
     WHERE OffTerm = 'FALL' AND OffYear = 2016 );

9.9
SELECT StdFirstName, StdLastName, StdCity, EnrGrade
 FROM Student, Enrollment 
 WHERE Student.StdNo = Enrollment.StdNo
   AND EnrGrade >= 3.5 AND Enrollment.OfferNo IN
   ( SELECT OfferNo FROM Offering 
	   WHERE OffTerm = 'FALL' AND OffYear = 2016 
        AND FacNo IN
	     ( SELECT FacNo  FROM Faculty 
                 WHERE FacFirstName = 'LEONARD' 
                   AND FacLastName = 'VINCE' )  );

9.10a
DELETE FROM Offering
 WHERE Offering.FacNo IN 
  ( SELECT FacNo FROM Faculty 
     WHERE FacFirstName = 'LEONARD' 
       AND FacLastName = 'VINCE' );

9.11a (new)
UPDATE Offering SET OffLocation = 'BLM412'
WHERE OffYear = 2017 AND FacNo IN
 ( SELECT FacNo FROM Faculty WHERE FacFirstName = 'LEONARD' AND FacLastName = 'FIBON')

9.12
SELECT FacNo, FacFirstName, FacLastName, FacDept,
       FacSalary
 FROM Faculty
 WHERE FacNo NOT IN
  ( SELECT StdNo FROM Student );

9.13 (Oracle 9i through 12c)
SELECT FacNo, FacFirstName, FacLastName, FacSalary
 FROM Faculty LEFT JOIN Student 
      ON Faculty.FacNo = Student.StdNo
 WHERE Student.StdNo IS NULL;

9.13 (Oracle 8i)
SELECT FacNo, FacFirstName, FacLastName, FacSalary
 FROM Faculty, Student
 WHERE Faculty.FacNo = Student.StdNo (+) 
   AND Student.StdNo IS NULL;

9.14
SELECT FacNo AS PerNo, FacFirstName AS FirstName, 
       FacLastName AS LastName, FacCity AS City, 
       FacState AS State 
 FROM Faculty
      MINUS
SELECT StdNo AS PerNo, StdFirstName AS FirstName,
       StdLastName AS LastName, StdCity AS City,
       StdState AS State 
 FROM Student;

9.15
SELECT DISTINCT FacNo, FacFirstName, FacLastName, 
                FacRank
 FROM Faculty, Student
 WHERE Student.StdNo <> Faculty.FacNo;

9.16
SELECT FacNo, FacFirstName, FacLastName, FacDept,
       FacSalary
 FROM Faculty
 WHERE NOT EXISTS
  ( SELECT * FROM Student
	  WHERE Student.StdNo = Faculty.FacNo );

9.17
SELECT FacNo, FacFirstName, FacLastName, FacDept,
       FacSalary
 FROM Faculty
 WHERE 0 = 
  ( SELECT COUNT(*) FROM Student
	  WHERE Student.StdNo = Faculty.FacNo );

9.18
SELECT DISTINCT Enrollment.StdNo, StdFirstName,
                StdLastName
 FROM Student, Enrollment, Offering
 WHERE Student.StdNo = Enrollment.StdNo 
          AND Enrollment.OfferNo = Offering.OfferNo 
          AND CourseNo LIKE 'IS%' AND OffTerm = 'WINTER'
   AND OffYear = 2017 AND NOT EXISTS
	( SELECT * FROM Enrollment E1, Offering O1
	   WHERE E1.OfferNo = O1.OfferNo 
        AND Enrollment.StdNo = E1.StdNo
		AND O1.CourseNo LIKE 'IS%' 
        AND O1.OffYear = 2017
        AND O1.OffTerm = 'WINTER'
  		AND Offering.FacNo <> O1.FacNo );

9.19
SELECT FacFirstName, FacLastName, FacDept
 FROM Faculty
 WHERE NOT EXISTS
  ( SELECT * FROM Offering
     WHERE Offering.FacNo = Faculty.FacNo
	    AND OffTerm = 'WINTER' AND OffYear = 2017 );

9.20
SELECT DISTINCT FacLastName, FacFirstName, FacDept
FROM faculty F1, offering O1
WHERE F1.FacNo = O1.FacNo 
        AND  OffTerm = 'WINTER' AND OffYear = 2017 
        AND NOT EXISTS
   ( SELECT * FROM Offering O2
     WHERE O2.FacNo = F1.FacNo
         AND   (OffTerm <> 'WINTER' OR OffYear <> 2017 ) );

9.21
SELECT T.CourseNo, T.CrsDesc, COUNT(*) AS NumOfferings, 
       Avg(T.EnrollCount) AS AvgEnroll
 FROM 
  ( SELECT Course.CourseNo, CrsDesc, 
           Offering.OfferNo, COUNT(*) AS EnrollCount
     FROM Offering, Enrollment, Course
     WHERE Offering.OfferNo = Enrollment.OfferNo
       AND Course.CourseNo = Offering.CourseNo
     GROUP BY Course.CourseNo, CrsDesc, Offering.OfferNo
      ) T    
 GROUP BY T.CourseNo, T.CrsDesc;

9.22
SELECT Faculty.FacNo, FacLastName, 
       COUNT(DISTINCT CourseNo) AS NumPreparations 
 FROM Faculty, Offering
 WHERE Faculty.FacNo = Offering.FacNo
 GROUP BY Faculty.FacNo, FacLastName;

9.23
SELECT T.FacNo, T.FacLastName, 
       COUNT(*) AS NumPreparations
FROM
 (  SELECT DISTINCT Faculty.FacNo, FacLastName, CourseNo
      FROM Offering, Faculty
      WHERE Offering.FacNo = Faculty.FacNo ) T
 GROUP BY T.FacNo, T.FacLastName;

9.24
SELECT StdNo 
 FROM StdClub
 GROUP BY StdNo
 HAVING COUNT(*) = ( SELECT COUNT(*) FROM Club );

9.25
SELECT StdNo 
 FROM StdClub, Club 
 WHERE StdClub.ClubNo = Club.ClubNo 
   AND CPurpose = 'SOCIAL'
 GROUP BY StdNo
 HAVING COUNT(*) = 
  ( SELECT COUNT(*) FROM Club 
    WHERE CPurpose = 'SOCIAL' );

9.26
SELECT Student1.StdNo, SName 
 FROM StdClub, Club, Student1
 WHERE StdClub.ClubNo = Club.ClubNo 
   AND Student1.StdNo = StdClub.StdNo
   AND CPurpose = 'SOCIAL'
 GROUP BY Student1.StdNo, SName
 HAVING COUNT(*) = 
  ( SELECT COUNT(*) FROM Club 
     WHERE CPurpose = 'SOCIAL' );

9.27
SELECT ClubNo 
 FROM StdClub, Student1
 WHERE Student1.StdNo = StdClub.StdNo 
   AND SCity = 'SEATTLE'
 GROUP BY ClubNo
 HAVING COUNT(*) = 
  ( SELECT COUNT(*) FROM Student1 
     WHERE SCity = 'SEATTLE' );

9.28
SELECT Faculty.FacNo, FacFirstName, FacLastName 
 FROM Faculty, Offering
 WHERE Faculty.FacNo = Offering.FacNo
   AND OffTerm = 'FALL' AND CourseNo LIKE 'IS%'
   AND OffYear = 2016
 GROUP BY Faculty.FacNo, FacFirstName, FacLastName
 HAVING COUNT(*) =
  ( SELECT COUNT(*) FROM Offering
    WHERE OffTerm = 'FALL' AND OffYear = 2016 
      AND CourseNo LIKE 'IS%' );

9.29
SELECT Faculty.FacNo, FacFirstName, FacLastName 
 FROM Faculty, Offering
 WHERE Faculty.FacNo = Offering.FacNo 
   AND OffTerm = 'FALL' AND CourseNo LIKE 'IS%'
   AND OffYear = 2016
 GROUP BY Faculty.FacNo, FacFirstName, FacLastName
 HAVING COUNT(DISTINCT CourseNo) =
  ( SELECT COUNT(DISTINCT CourseNo) FROM Offering
     WHERE OffTerm = 'FALL' AND OffYear = 2016 
       AND CourseNo LIKE 'IS%' );

9.31
SELECT Faculty.FacNo, FacFirstName, FacLastName 
 FROM Faculty, Offering, Enrollment, Student
 WHERE Faculty.FacNo = Offering.FacNo 
   AND OffTerm = 'FALL' AND CourseNo LIKE 'IS%'
   AND OffYear = 2016 AND StdClass = 'SR'
   AND Offering.OfferNo = Enrollment.OfferNo
   AND Student.StdNo = Enrollment.StdNo
 GROUP BY Faculty.FacNo, FacFirstName, FacLastName
 HAVING COUNT(DISTINCT Student.StdNo) =
  ( SELECT COUNT(*) FROM Student 
     WHERE StdClass = 'SR' );

9.32
SELECT FacNo, FacFirstName, FacLastName 
 FROM 
  ( SELECT DISTINCT Faculty.FacNo, FacFirstName,
           FacLastName, Student.StdNo
     FROM Faculty, Offering, Enrollment, Student
     WHERE Faculty.FacNo = Offering.FacNo 
       AND OffTerm = 'FALL' AND CourseNo LIKE 'IS%'
       AND OffYear = 2016 AND StdClass = 'SR'
       AND Offering.OfferNo = Enrollment.OfferNo
       AND Student.StdNo = Enrollment.StdNo )
 GROUP BY FacNo, FacFirstName, FacLastName
 HAVING COUNT(*) =
  ( SELECT COUNT(*) FROM Student 
     WHERE StdClass = 'SR' );

-- CREATE TABLE and INSERT statements for student club examples used in Section 9.4

create table Club (
ClubNo		char(6) not null,
CName		varchar2(10) not null,
CPurpose	varchar2(10) not null,
CBudget		Number(10,2),
CActual		Number(10,2),
CONSTRAINT ClubPk PRIMARY KEY (ClubNo) );

INSERT INTO club
	(ClubNo, CName, CPurpose, CBudget, CActual )
	VALUES('C1','DELTA','SOCIAL',1000.00,1200.00);


INSERT INTO club
	(ClubNo, CName, CPurpose, CBudget, CActual )
	VALUES('C2','BITS','ACADEMIC',500.00,350.00);

INSERT INTO club
	(ClubNo, CName, CPurpose, CBudget, CActual )
	VALUES('C3','HELPS','SERVICE',300.00,330.00);

INSERT INTO club
	(ClubNo, CName, CPurpose, CBudget, CActual )
	VALUES('C4','SIGMA','SOCIAL','',150.00);

create table Student1 (
StdNo		char(6) not null,
SName		varchar2(10) not null,
SCity		varchar2(10) not null,
CONSTRAINT Student1Pk PRIMARY KEY (StdNo) );

INSERT INTO student1
	(StdNo, SName, SCity )
	VALUES('S1','JOE','SEATTLE');

INSERT INTO student1
	(StdNo, SName, SCity )
	VALUES('S2','SALLY','SEATTLE');

INSERT INTO student1
	(StdNo, SName, SCity )
	VALUES('S3','SUE','PORTLAND');


create table StdClub (
ClubNo		char(6) not null,
StdNo		char(6) not null,
CONSTRAINT StdClubPk PRIMARY KEY (ClubNo,StdNo),
CONSTRAINT ClubFK FOREIGN KEY (ClubNo) REFERENCES Club,
CONSTRAINT Student2FK FOREIGN KEY (StdNo) REFERENCES Student1 );

INSERT INTO stdclub
	(StdNo, ClubNo )
	VALUES('S1','C1');

INSERT INTO stdclub
	(StdNo, ClubNo )
	VALUES('S1','C2');

INSERT INTO stdclub
	(StdNo, ClubNo )
	VALUES('S1','C3');

INSERT INTO stdclub
	(StdNo, ClubNo )
	VALUES('S1','C4');

INSERT INTO stdclub
	(StdNo, ClubNo )
	VALUES('S2','C1');

INSERT INTO stdclub
	(StdNo, ClubNo )
	VALUES('S2','C4');

INSERT INTO stdclub
	(StdNo, ClubNo )
	VALUES('S3','C3');



9.33
SELECT * 
 FROM Club
 WHERE CBudget > 200;

9.34
SELECT * 
 FROM Club
 WHERE CBudget > CActual;

9.35
SELECT * 
 FROM Club
 WHERE CBudget <= CActual;

9.36
SELECT * 
 FROM Club
 WHERE CBudget <= CActual  OR  CActual < 200;

9.37
SELECT * 
 FROM Club
 WHERE CBudget <= CActual  AND  CActual < 500;

9.38
SELECT COUNT(*) AS NumRows, 
       COUNT(CBudget) AS NumBudgets 
 FROM Club;

9.39
SELECT SUM(CBudget) AS SumBudget, 
       SUM(CActual) AS SumActual, 
       SUM(CBudget)-SUM(CActual) AS SumDifference,
       SUM(CBudget-CActual) AS SumOfDifferences
 FROM Club;

9.40
SELECT FacNo, COUNT(*) AS NumRows 
 FROM Offering
 GROUP BY FacNo;

-- CREATE TABLE statement and INSERT statements for queries in Section 9.5

create table Faculty2(
FacNo			char(11) not null,
FacFirstName		varchar2(10) not null,
FacLastName		varchar2(10) not null,
FacRank			char(4),
FacHireDate		date,
FacSalary		decimal(10,2),
FacSupervisor		char(11),
CONSTRAINT Faculty2PK PRIMARY KEY (FacNo), 
CONSTRAINT Supervisor2FK FOREIGN KEY (FacSupervisor) REFERENCES Faculty2 );

INSERT INTO faculty2
	(FacNo, FacFirstName, FacLastName, FacRank, FacSalary, FacSupervisor, FacHireDate)
	 VALUES ('543-21-0987','VICTORIA','EMMANUEL','PROF',120000.0,'','15-Apr-2001');

INSERT INTO faculty2
	(FacNo, FacFirstName, FacLastName, FacRank, FacSalary, FacSupervisor, FacHireDate)
	 VALUES ('765-43-2109','NICKI','MACON','ASSC',105000.00,'','11-Apr-2002');

INSERT INTO faculty2
	(FacNo, FacFirstName, FacLastName, FacRank, FacSalary, FacSupervisor, FacHireDate)
	 VALUES ('654-32-1098','LEONARD','FIBON','ASSC',70000.00,'543-21-0987','01-May-1999');

INSERT INTO faculty2
	(FacNo, FacFirstName, FacLastName, FacRank, FacSalary, FacSupervisor, FacHireDate)
	 VALUES ('098-76-5432','LEONARD','VINCE','ASST',55000.00,'654-32-1098','10-Apr-2000');

INSERT INTO faculty2
	(FacNo, FacFirstName, FacLastName, FacRank, FacSalary, FacSupervisor, FacHireDate)
	 VALUES ('876-54-3210','CRISTOPHER','COLAN','ASST',90000.00,'654-32-1098','01-Mar-2004');

INSERT INTO faculty2
	(FacNo, FacFirstName, FacLastName, FacRank, FacSalary, FacSupervisor, FacHireDate)
	 VALUES ('987-65-4321','JULIA','MILLS','ASSC',95000.00,'765-43-2109','15-Mar-2005');

INSERT INTO faculty2
	(FacNo, FacFirstName, FacLastName, FacRank, FacSalary, FacSupervisor, FacHireDate)
	 VALUES ('111-22-3333','JOHN','MILLSON','PROF',110000.00,'543-21-0987','01-May-2005');

INSERT INTO faculty2
	(FacNo, FacFirstName, FacLastName, FacRank, FacSalary, FacSupervisor, FacHireDate)
	 VALUES ('333-22-4444','SALLY','SCOTT','ASST',90000.00,'111-22-3333','01-May-2006');

INSERT INTO faculty2
	(FacNo, FacFirstName, FacLastName, FacRank, FacSalary, FacSupervisor, FacHireDate)
	 VALUES ('555-66-7777','SUSAN','JONES','ASSC',125000.00,'111-22-3333','01-May-2007');

INSERT INTO faculty2
	(FacNo, FacFirstName, FacLastName, FacRank, FacSalary, FacSupervisor, FacHireDate)
	 VALUES ('777-11-4321','AIMEE','MANNING','ASST',85000.00,'765-43-2109','15-Mar-2006');

INSERT INTO faculty2
	(FacNo, FacFirstName, FacLastName, FacRank, FacSalary, FacSupervisor, FacHireDate)
	 VALUES ('888-33-1111','JAMES','BLOKE','ASST',85000.00,'987-65-4321','15-Apr-2008');

INSERT INTO faculty2
	(FacNo, FacFirstName, FacLastName, FacRank, FacSalary, FacSupervisor, FacHireDate)
	 VALUES ('789-12-3210','JAIME','SANCHEZ','PROF',107000.00,'987-65-4321','10-May-2009');


-- Example 9.41
-- The basic formulation visits a row for each level on a path. For example, a leaf node on level 3 is visited 3 times.
-- LEVEL is a pseudo column which is used in a hierarchical query to identify the hierarchy level in numeric format. 
-- For each row returned by a hierarchical query, the LEVEL pseudocolumn returns 1 for a root row, 2 for a child of a root, and so on.
-- Pseudocolumns are not actual columns in a table, but they behave like columns.
-- All values are the same except the level.
-- 28 rows: 6 leaf nodes at level 3 (18 rows), 4 nodes at level 2 (8), 2 root nodes
SELECT FacNo, FacSupervisor, FacFirstName, FacLastName, FacHireDate, FacRank, FacSalary, LEVEL
FROM Faculty2
CONNECT BY PRIOR FacNo = FacSupervisor
ORDER BY FacNo, LEVEL;

-- Example 9.42
-- USE START WITH to visit each row one time. Start with the root employees.
SELECT FacNo, FacSupervisor, FacFirstName, FacLastName, FacHireDate, FacRank, FacSalary, LEVEL
FROM Faculty2
START WITH FacSupervisor IS NULL
CONNECT BY PRIOR FacNo = FacSupervisor
ORDER BY LEVEL;

-- Example 9.43
-- Show hierarchical organization using the LPAD (left padding) function. 
SELECT LPAD(' ',2*(Level-1)) || FacLastName AS LastName, FacHireDate, FacSalary, FacRank, LEVEL
FROM Faculty2
START WITH FacSupervisor IS NULL
CONNECT BY PRIOR FacNo = FacSupervisor
ORDER SIBLINGS by FacLastName;

-- Example 9.44
-- Show hierarchical organization using the SYS_CONNECT_BY_PATH function. The second parameter specifies the separator between nodes on a path.
-- Returns the path of a column value from root to node, with column values separated by char for each row returned by CONNECT BY condition

SELECT SYS_CONNECT_BY_PATH(FacLastName,'/') AS Path, FacHireDate, FacSalary, FacRank, LEVEL
FROM Faculty2
START WITH FacSupervisor IS NULL
CONNECT BY PRIOR FacNo = FacSupervisor
ORDER SIBLINGS by FacLastName;

-- Example 9.45
-- Show root and leaf status using the CONNECT_BY_ROOT function and the CONNECT_BY_ISLEAF function.
SELECT SYS_CONNECT_BY_PATH(FacLastName,'/') AS Path, CONNECT_BY_ROOT FacLastName AS Root, CONNECT_BY_ISLEAF AS IsLeaf, LEVEL, FacHireDate, FacSalary, FacRank 
FROM Faculty2
START WITH FacSupervisor IS NULL
CONNECT BY PRIOR FacNo = FacSupervisor
ORDER SIBLINGS by FacLastName;

-- Example 9.46
-- Compute total compensation for each employee and subordinate employees
-- A nested query in the FROM clause is necessary because CONNECT_BY_ROOT cannot be used as a grouping column.
-- This statement generates one row per faculty member.
SELECT Root, COUNT(*)-1 AS NumSubordinates, SUM(FacSalary) AS FacSalarySum
FROM
 ( SELECT CONNECT_BY_ROOT FacLastName AS Root, FacSalary
    FROM Faculty2 
    CONNECT BY PRIOR FacNo = FacSupervisor )
GROUP BY Root
ORDER BY COUNT(*) DESC

-- Example 9.47
-- Generate the transitive closure using a hierarchical subquery and WHERE condition to eliminate rows not part of the closure.
SELECT *
FROM 
( SELECT FacNo, PRIOR FacNo AS PriorFacNo, CONNECT_BY_ROOT FacNo AS FacSupNo, FacFirstName, FacLastName, LEVEL AS PathLevel, FacSalary, FacRank, 
         SYS_CONNECT_BY_PATH(FacLastName,'/') AS Path
   FROM Faculty2
   CONNECT BY PRIOR FacNo = FacSupervisor )
WHERE FacSupNo <> FacNo
ORDER BY FacLastName, PathLevel;

-- Example 9.48
-- Supervisors earning less than subordinates
SELECT F1.FacNo, Root AS FacSupNo, F1.FacLastname, F2.FacLastName AS FacSupLastName, F1.FacSalary, F2.FacSalary AS FacSupSalary, Path
FROM 
( SELECT FacNo, FacSupervisor, CONNECT_BY_ROOT FacNo AS Root, SYS_CONNECT_BY_PATH(FacLastName,'/') AS Path, FacLastName, FacSalary
   FROM Faculty2
   CONNECT BY PRIOR FacNo = FacSupervisor ) F1 INNER JOIN Faculty2 F2 ON Root = F2.FacNo
WHERE Root <> F1.FacNo AND F1.FacSalary > F2.FacSalary;

SELECT *
FROM 
( SELECT FacNo, CONNECT_BY_ROOT FacNo AS FacSupNo, FacLastName, CONNECT_BY_ROOT FacLastName AS FacSupLastLastName, 
                FacSalary, CONNECT_BY_ROOT FacSalary AS FacSupSalary
   FROM Faculty2
   CONNECT BY PRIOR FacNo = FacSupervisor )
WHERE FacSupNo <> FacNo AND FacSalary > FacSupSalary;

-- Example 9.49
-- Supervisors with lower rank than subordinates
-- Ranking order: PROF > ASSC > ASST
SELECT F1.FacNo, Root AS FacSupNo, F1.FacLastname, F2.FacLastName AS FacSupLastName, F1.FacRank, F2.FacRank AS FacSupRank, Path
FROM 
( SELECT FacNo, FacSupervisor, CONNECT_BY_ROOT FacNo AS Root, SYS_CONNECT_BY_PATH(FacLastName,'/') AS Path, FacLastName, FacRank
   FROM Faculty2
   CONNECT BY PRIOR FacNo = FacSupervisor ) F1 INNER JOIN Faculty2 F2 ON Root = F2.FacNo
WHERE Root <> F1.FacNo 
  AND ( ( F1.FacRank = 'PROF' AND F2.FacRank = 'ASSC' )  OR ( F1.FacRank = 'PROF' AND F2.FacRank = 'ASST' ) 
   OR ( F1.FacRank = 'ASSC' AND F2.FacRank = 'ASST' ) );

-- Example 9.51
-- Recursive CTE equivalent to Example 9.42

WITH Faculty2CTE ( FacNo, FacSupervisor, FacFirstName, 
  FacLastName, FacHireDate, FacRank, FacSalary, LevelNo )
AS
( SELECT FacNo, FacSupervisor, FacFirstName, FacLastName, 
         FacHireDate, FacRank, FacSalary, 1
  FROM Faculty2
  WHERE FacSupervisor IS NULL
-- AM referencing Faculty2, the hierarchical table.
UNION ALL
  SELECT F2.FacNo, F2.FacSupervisor, F2.FacFirstName, 
         F2.FacLastName, F2.FacHireDate, F2.FacRank, 
         F2.FacSalary, F2CTE.LevelNo + 1
  FROM Faculty2 F2 INNER JOIN Faculty2CTE F2CTE
    ON F2.FacSupervisor = F2CTE.FacNo
)
-- Statement using the CTE
SELECT * FROM Faculty2CTE
ORDER BY LevelNo, FacNo;

-- Recursive CTE to generate the transitive closure (all reachable pairs; direct and indirect subordinates)
WITH Faculty2CTE ( FacNo, FacFirstName, FacLastName, 
                   FacSupervisor, LevelNo )
AS
( SELECT FacNo, FacFirstName, FacLastName, FacSupervisor, 0
  FROM Faculty2
-- AM referencing Faculty2, the hierarchical table.
UNION ALL
  SELECT F2.FacNo, F2.FacFirstName, F2.FacLastName, 
         F2CTE.FacSupervisor, F2CTE.LevelNo + 1
  FROM Faculty2 F2 INNER JOIN Faculty2CTE F2CTE
    ON F2.FacSupervisor = F2CTE.FacNo
)
-- Statement using the CTE
SELECT * FROM Faculty2CTE
WHERE LevelNo = 0 OR FacSupervisor IS NOT NULL ;

-- Example 9.52 equivalent to Example 9.48
-- Path exception queries: show monotonicity exceptions on a path (ancestor has less value than descendant)
-- Can only be performed with recursive CTE because PRIOR shows only parent not ancestor data

-- Supervisors earning less than subordinates
WITH Faculty2CTE ( FacNo, FacSupNo, FacLastName, FacSupLastName, FacSalary, FacSupSalary )             
AS
( SELECT F1.FacNo, F1.FacSupervisor, F1.FacLastName,  F1Sup.FacLastName, F1.FacSalary, F1Sup.FacSalary
  FROM Faculty2 F1 INNER JOIN Faculty2 F1Sup ON F1.FacSupervisor = F1Sup.FacNo
-- AM referencing Faculty2, the hierarchical table.
UNION ALL
  SELECT F2.FacNo, F2CTE.FacSupNo, F2.FacLastName, F2CTE.FacSupLastName, F2.FacSalary, F2CTE.FacSupSalary       
  FROM Faculty2 F2 INNER JOIN Faculty2CTE F2CTE
    ON F2.FacSupervisor = F2CTE.FacNo
)
-- Statement using the CTE
SELECT * FROM Faculty2CTE
WHERE FacSupNo <> FacNo AND FacSalary > FacSupSalary;

-- Example 9.53 equivalent to Example 9.49
-- Supervisors with lower rank than subordinates
-- Ranking order: PROF > ASSC > ASST
WITH Faculty2CTE ( FacNo, FacSupNo, FacLastName, FacSupLastName, FacRank, FacSupRank )                
AS
( SELECT F1.FacNo, F1.FacSupervisor, F1.FacLastName,  F1Sup.FacLastName, F1.FacRank, F1Sup.FacRank
  FROM Faculty2 F1 INNER JOIN Faculty2 F1Sup ON F1.FacSupervisor = F1Sup.FacNo
-- AM referencing Faculty2, the hierarchical table.
UNION ALL
  SELECT F2.FacNo, F2CTE.FacSupNo, F2.FacLastName, F2CTE.FacSupLastName, F2.FacRank, F2CTE.FacSupRank
  FROM Faculty2 F2 INNER JOIN Faculty2CTE F2CTE
    ON F2.FacSupervisor = F2CTE.FacNo
)
-- Statement using the CTE
SELECT * FROM Faculty2CTE
WHERE FacSupNo <> FacNo 
  AND ( ( FacRank = 'PROF' AND FacSupRank = 'ASSC' )  OR ( FacRank = 'PROF' AND FacSupRank = 'ASST' ) 
   OR ( FacRank = 'ASSC' AND FacSupRank = 'ASST' ) );



